#ifndef _CONTEXTS_H_
#define _CONTEXTS_H_

typedef struct context_tag {
  int   id;
  char *name;
  int   scope;
  int   lexic;
  } context_t;

#define OC_CX_ALL         ((int)(0x000001))
#define OC_CX_PUB         ((int)(0x000002))
#define OC_CX_PUB_BR      ((int)(0x000003))
#define OC_CX_PUB_NM      ((int)(0x000004))
#define OC_CX_PUB_FR      ((int)(0x000005))
#define OC_CX_PUB_FOE     ((int)(0x000006))
#define OC_CX_PUB_TXT     ((int)(0x000007))
#define OC_CX_PRI         ((int)(0x000008))
#define OC_CX_PRI_BR      ((int)(0x000009))
#define OC_CX_PRI_AS      ((int)(0x00000A))
#define OC_CX_PRI_FR      ((int)(0x00000B))
#define OC_CX_PRI_FOE     ((int)(0x00000C))
#define OC_CX_PRI_NM      ((int)(0x00000D))
#define OC_CX_PRI_TXT     ((int)(0x00000E))
#define OC_CX_WHO         ((int)(0x00000F))
#define OC_CX_WHO_HD      ((int)(0x000010))
#define OC_CX_WHO_HD_NM   ((int)(0x000011))
#define OC_CX_WHO_HD_MOD  ((int)(0x000012))
#define OC_CX_WHO_HD_TOP  ((int)(0x000013))
#define OC_CX_WHO_TXT     ((int)(0x000014))
#define OC_CX_WHO_NM      ((int)(0x000015))
#define OC_CX_WHO_MOD     ((int)(0x000016))
#define OC_CX_WHO_IDLE    ((int)(0x000017))
#define OC_CX_WHO_LOGIN   ((int)(0x000018))
#define OC_CX_WHO_ADDR    ((int)(0x000019))
#define OC_CX_WHO_NR      ((int)(0x00001A))
#define OC_CX_ANN         ((int)(0x00001B))
#define OC_CX_ANN_BR      ((int)(0x00001C))
#define OC_CX_ANN_IN      ((int)(0x00001D))
#define OC_CX_ANN_TXT     ((int)(0x00001E))
#define OC_CX_CMD         ((int)(0x00001F))
#define OC_CX_CMD_BR      ((int)(0x000020))
#define OC_CX_CMD_IN      ((int)(0x000021))
#define OC_CX_CMD_TXT     ((int)(0x000022))
#define OC_CX_ORC         ((int)(0x000023))
#define OC_CX_ORC_BR      ((int)(0x000024))
#define OC_CX_ORC_IN      ((int)(0x000025))
#define OC_CX_ORC_TXT     ((int)(0x000026))
#define OC_CX_SENTRY      ((int)(0x000027))

#define OC_NCONTEXTS OC_CX_SENTRY

#ifndef _CONTEXTS_C_

extern context_t *context_dir;

#endif
#endif
