/* CQUEUE.C */
/* The command queue is the generic interface used for any */
/* component which wants to generate client commands.      */
/* Commands to be performed are passed to push_command_queue, */
/* which are retrieved in order through pull_command_queue.   */
/* The got_command_queue() function returns the number of     */
/* command strings currently waiting in the queue.            */
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#define FORLOOP(I,K) for(I=0;I<K;I++)

extern void scrub_free ( char*, int );

char  *retbuf;  /* nonvolatile return buffer */
int    retbufmag;
char **queue;
int    qmax;
int    qmag;
int    cqstat = 0;

void  init_command_queue() {
  int i;
  qmag = 0;
  qmax = 16;
  retbufmag = 0;
  queue = (char**) malloc ( sizeof (char*) * 16 );
  cqstat = 1;
  }

void  nuke_command_queue() {
  int i;
  if ( cqstat != 1 ) return;
  qmag = 0;
  qmax = 0;
  FORLOOP(i,qmag) scrub_free ( queue[i], strlen(queue[i]) );
  scrub_free ( (char*)queue, sizeof(char*) * qmax );
  }

void  dump_command_queue() {
  int i;
  FORLOOP(i,qmag) oprint ("[=CQUEUE=] %u: '%s'\n", i, queue[i]);
  }

void  push_command_queue( command ) char *command; {
  if ( command[0] < ' ' ) return;
  if ( qmag == qmax ) {
    char **newq;
    int    i;
    newq = (char**) malloc ( sizeof(char*) * ( qmax + qmax ) );
    FORLOOP(i,qmax) newq[i] = queue[i];
    scrub_free( (char*)queue, sizeof(char*) * qmax );
    qmax += qmax;
    queue = newq;
    }
  queue[qmag] = strdup ( command );
  qmag++;
  }

char *pull_command_queue() {
  int i;
  if ( retbufmag > strlen(queue[0]) ) {
    strcpy ( retbuf, queue[0] );
    } else {
    scrub_free ( retbuf, retbufmag );
    retbuf = queue[0];
    retbufmag = strlen(retbuf+1);
    }
  FORLOOP(i,qmag-1) queue[i] = queue[i+1];
  qmag--;
  return retbuf;
  }

int   got_command_queue() { return qmag; }
