/* CQUEUE.H */
/* The command queue is the generic interface used for any */
/* component which wants to generate client commands.      */
/* Commands to be performed are passed to push_command_queue, */
/* which are retrieved in order through pull_command_queue.   */
/* The got_command_queue() function returns the number of     */
/* command strings currently waiting in the queue.            */
/* nuke_command_queue() should be called to safely scrub the  */
/* command queue memory space clean of any residual data.     */

void  init_command_queue();  
void  nuke_command_queue();
void  push_command_queue( char* );
char *pull_command_queue();
int   got_command_queue();
void  dump_command_queue();
