/**
/* $Id: prototypes.h,v 1.3 1998/02/13 09:00:19 falcon Exp $
/* This file contains prototypes for all the functions used in orcus 
/**/

#ifndef _PROTOTYPES_H_
#define _PROTOTYPES_H_

#include <signal.h>
#include "signals.h"

/* string linked list types */
typedef struct strltag {  /* list of strings */
  char *d;
  struct strltag *next;
} strl;

typedef struct lroottag { /* list root */
  int   n;
  strl *h,*t;  /* head and tail pointers */
} lroot;

/* tty functions */
int sttyinputset(void);
int sttyinputreset(void);

/* quit and cleanup  functions */
int quit(int *confirm_quit);
int orc_quit();
void dont_quit(void);

int fdpoll(int fd);
void more_prompt();
void go_show_open_message(char *stub, char *buf);
void go_show_pers_message(char *stub, char *buf);
void go_show_status_update(char *stub, char *buf);
void go_show_wholine(char *buf);
void go_show_command_output(char *stub, char *buf);
void go_login_verified();
void go_we_must_exit();
void go_protocol_version();
void go_show_error(char *buf); 
void go_announcement(char *what, char *buf);
void go_gotum_beep(char *buf);
void go_gotum_ping(char *buf);
char *nibble(char *buf, int n);
char *gobble(char *buf, int n);
void nab_one (char *buf, int n, char *dest);
void nab_rest (char *buf, int n, char *dest);
int analyze_input_string(char *buf);

/* readline stuff */
int _readln(char *buf);
int emacs_readln(char *buf);

/* custom signal functions */
Sigfunc * my_signal(int signo, Sigfunc *func);
void catch_signals(void);
static void sig_default(int signo);
static void sig_hup(int signo);
static void sig_int(int signo);
static void sig_cont(int signo);
static void sig_segv(int signo);

#endif
